//
//  KMAdvertisementBaseView.swift
//  KMAdvertisement
//
//  Created by lizhe on 2022/12/3.
//

#if os(OSX)
    import AppKit
#elseif os(iOS)
    import UIKit
#endif

@objc public enum KMAdvertisementBaseViewActionType: Int {
    case unknow = 0 //不知道
    case cancel //取消
    case tap //点击
}

public typealias KMAdvertisementActionCompletion = (_ actionType: KMAdvertisementBaseViewActionType, _ actionItem: KMAdvertisementModelItem) -> Void
public typealias KMAdvertisementLoadCompletion = (_ data: [KMAdvertisementModelSection]) -> Void

@objc open class KMAdvertisementBaseView: NSView {
    public var actionCompletion: KMAdvertisementActionCompletion?
    public var loadCompletion: KMAdvertisementLoadCompletion?
}
